#!/usr/bin/env python
#---------------------------------------------------------------
# Project         : Linux-Mandrake
# Module          : rpm-rebuilder
# File            : add-buildrequires.py
# Version         : $Id: add-buildrequires.py,v 1.2 2000/10/01 17:58:35 flepied Exp $
# Author          : Frederic Lepied
# Created On      : Sat Aug  5 20:51:52 2000
#---------------------------------------------------------------

import specfile
import sys
import string
import re

if len(sys.argv) != 5:
    sys.stderr.write("usage: %s <spec file> <dep file> <email> <changelog>\n" % sys.argv[0])
    sys.exit(1)
else:
    s=specfile.specfile(sys.argv[1])
    name=s.lookupField("Name")
    buildprereq=s.lookupField("BuildPrereq")
    if buildprereq:
        buildprereq=re.split("[, ]+", buildprereq)
    buildrequires=s.lookupField("BuildRequires")
    if buildrequires:
        buildrequires=re.split("[, ]+", buildrequires)
    else:
        buildrequires=[]
        
    changed=0
    env={}
    execfile(sys.argv[2], env)
    dep=env['dep']

    try:
        pkg_dep=dep[name]
    except KeyError:
        sys.exit(1)
        
    for d in pkg_dep:
        if not ((buildrequires and d in buildrequires) or (buildprereq and d in buildprereq)):
            changed=1
            buildrequires.append(d)
    
    if changed:
        s.incrementRelease(sys.argv[3], sys.argv[4])
        str=string.join(buildrequires, " ")
        s.replaceField('BuildRequires', str)
        sys.stderr.write('adding BuildRequires: ' + str + "\n")
        try:
            s.dump()
            sys.exit(0)
        except IOError:
            sys.exit(1)
    else:
        sys.exit(1)
        
# add-buildrequires ends here
